// Better sequencer which uses interrupts

#include <Adafruit_MCP4728.h>
#include <Wire.h>

Adafruit_MCP4728 mcp;

#define nsamp 256
#define dacmax 256

byte waveform[nsamp];

unsigned int phase;
unsigned int length = 256;

int pd = 1;



int note = 0;
// int pitch[] = { 0, 1, 2, 3, 4, 5, 6, 7, 0, 1, 2, 3, 4, 5, 6, 7 };
// float dur[] = { 1, 0.5, 0.25, 0.1, 1, 0.5, 0.25, 0.1,1, 0.5, 0.25, 0.1,1, 0.5, 0.25, 0.1 };

int pitch[] = { 8, -1, -1, -1, 8,-1, -1, -1, -1,-1, 8, -1, -1, -1, 8, 8, };
float dur[] = { 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1 };


int phrase = 16;

int s;
int beat_m = 100; // fix me coordinate with timer code
bool noteon = false;
int beat = false;
long notestart, notedur;


void setup() {

  cli();

//set timer1 interrupt at 1Hz
  TCCR1A = 0;// set entire TCCR1A register to 0
  TCCR1B = 0;// same for TCCR1B
  TCNT1  = 0;//initialize counter value to 0
  // set compare match register for 1hz increments
  //OCR1A = 15624;// = (16*10^6) / (1*1024) - 1 (must be <65536)
  //OCR1A = 7812;// = (16*10^6) / (1*1024) - 1 (must be <65536)
  OCR1A = 800;
  // turn on CTC mode
  TCCR1B |= (1 << WGM12);
  // Set CS10 and CS12 bits for 1024 escaler
  TCCR1B |= (1 << CS12) | (1 << CS10);  
  // enable timer compare interrupt
  TIMSK1 |= (1 << OCIE1A);

  sei();



  if (!mcp.begin(0x64)) {
    while (1) {
      delay(100);
    }
  }

  // randomSeed(analogRead(A0));
  make_noise();
  mcp.setSpeed(800000L);
  note=0;
}

void make_noise() {
  for (int i=0; i<nsamp; ++i){  
      waveform[i]=random(256);
    }

}



ISR(TIMER1_COMPA_vect){ // called once every note
  beat = true;
  length = analogRead(A0) >> 4;
}



void loop() {
  long now = millis();
  if( beat ) {
    beat = false;
    if( pitch[s] > -1 ) {
      notestart = millis();
      notedur = round(beat_m * dur[s]);
      noteOn();
      noteon = true;
    }
    s += 1;
    if( s == phrase ) {
      s = 0;
    }
  } else {
    if( noteon ) {
      if( now - notestart > notedur ) {
        noteOff();
        noteon = false;
      }
    }
  }
  phase += 1;
  if( phase >= length ) {
    phase = 0;
  }
    mcp.setChannelValue(MCP4728_CHANNEL_A,waveform[phase] << 4);


}


void noteOn() {
  if( note > -1 ) {
    mcp.setChannelValue(MCP4728_CHANNEL_B, 4095);
  }
}

void noteOff() {
    mcp.setChannelValue(MCP4728_CHANNEL_B, 0);
}


